<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2007 Pierre Rouwens <prouwens@hotmail.fr>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
* 
*  The video player swf is developped by Neolao http://www.player-flv.net
*  refer to the website for the licence.
***************************************************************/

require_once(PATH_tslib.'class.tslib_pibase.php');


/**
 * Plugin 'FLV Player' for the 'rsp_flvplayer' extension.
 *
 * @author	Pierre Rouwens <prouwens@hotmail.fr>
 * @package	TYPO3
 * @subpackage	tx_rspflvplayer
 */
class tx_rspflvplayer_pi1 extends tslib_pibase {
	var $prefixId      = 'tx_rspflvplayer_pi1';		// Same as class name
	var $scriptRelPath = 'pi1/class.tx_rspflvplayer_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey        = 'rsp_flvplayer';	// The extension key.
	var $pi_checkCHash = true;
	var $lDebug = false;
    
	/**
	 * The main method of the PlugIn
	 *
	 * @param	string		$content: The PlugIn content
	 * @param	array		$conf: The PlugIn configuration
	 * @return	The content that is displayed on the website
	 */
	function main($content,$conf)	{
		$this->conf=$conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
        
        // on va charger le JS
        $js .= '<script src="'.t3lib_extMgm::siteRelPath($this->extKey).'res/swfobject/swfobject.js" type="text/javascript"><!-- //--></script>';
        $GLOBALS['TSFE']->additionalHeaderData[$this->extKey] = $js;
        // On charge la flexform de configuration
        $this->pi_initPIflexform();
        $this->flexSheets = array('confFilm','confPlayer');
        switch($this->pi_getFFvalue($this->cObj->data['pi_flexform'], "player", "sDEF")) {
            // Player MAXI
            case 1:
            // Player MULTI
            case 2:
            // Player JS
            case 3:
            default:
                $content .= $this->getPlayer();
            break;
        }
	
		return $this->pi_wrapInBaseClass($content);
	}
    
    function getPlayerConfiguration() {
        $conf['flv'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], "flv", "sDEF");
        $conf['width'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], "width", "sDEF");
        $conf['height'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], "height", "sDEF");
        $conf['buffermessage'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'],"buffermessage","confPlayer");
        
        $lConf = array();
        $piFlexForm = $this->cObj->data['pi_flexform'];
        foreach ( $piFlexForm['data'] as $sheet => $data ) {
            if(in_array($sheet,$this->flexSheets)) {
                foreach ( $data as $lang => $value ) {
                    foreach ( $value as $key=>$val ) {
                        $lConf[$key] = $this->pi_getFFvalue($piFlexForm, $key, $sheet);
                    }
                }
            }
            
        }
        if($this->lDebug) debug($lConf,'$lConf');
        return $lConf;
    }
    
    
    /**
    * @desc Generate the HTML code for the maxi player
    * 
    * @return string the HTML code for the maxi player
    */
    function getPlayer() {        
        $confString = '';
        $lconf = $this->getPlayerConfiguration();
        if (empty($lconf['flv'])) {
            $lconf['flv'] = 'http://download.neolao.com/videos/KyodaiNoGilga.flv';
        } else {
            $lconf['flv'] = rawurlencode(t3lib_div::getIndpEnv('TYPO3_SITE_URL').'uploads/tx_rspflvplayer/'.$lconf['flv']);
            //$lconf['flv'] = t3lib_div::getIndpEnv('TYPO3_SITE_URL').'uploads/tx_rspflvplayer/'.$lconf['flv'];
        }
        if(!empty($lconf['startimage']))
            $lconf['startimage'] = rawurlencode(t3lib_div::getIndpEnv('TYPO3_SITE_URL').'uploads/tx_rspflvplayer/'.$lconf['startimage']);
            //$lconf['startimage'] = t3lib_div::getIndpEnv('TYPO3_SITE_URL').'uploads/tx_rspflvplayer/'.$lconf['startimage'];
        $lcontent[] = '<div id="flashcontent">
                        This text is replaced by the Flash movie.
                        </div>
                        <script type="text/javascript">
                        var so = new SWFObject("'.t3lib_div::getIndpEnv('TYPO3_SITE_URL').t3lib_extmgm::siteRelPath($this->extKey).'res/players/player_flv_maxi.swf'.'", "mymovie", "'.$lconf['width'].'", "'.$lconf['height'].'", "8", "#336699");
                        so.addParam("allowFullScreen","true");';
        foreach($lconf as $itemConf=>$value) {
            if($this->lDebug) debug($itemConf,"$itemConf");
            $lcontent[] = 'so.addVariable("'.$itemConf.'","'.$value.'");';
        }
        $lcontent[] = 'so.write("flashcontent");';
        $lcontent[] = '</script>';
        if($this->lDebug) debug($lcontent,"$lcontent");
        return implode(chr(10),$lcontent);
    }
}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/rsp_flvplayer/pi1/class.tx_rspflvplayer_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/rsp_flvplayer/pi1/class.tx_rspflvplayer_pi1.php']);
}

?>